//Fortran: EQUIVALENCE ( ... )
Unit SF62R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure SF62R(NN :Integer; XX :Real; var ENX :Real;
                var EXPENX :Real);

implementation

procedure SF62R(NN :Integer; XX :Real; var ENX :Real;
                var EXPENX :Real);
var
N :Integer;
X,RN,RM,TM,D,PSI,SUM,ASUM,XLOG,FMM2,FMM1,GMM2,GMM1,PREV,RNM1,AM,BM,FM,
   F,EXPNX,EULER,PTERM,R,GM,TEMP :Real;
const
SYS056 :Real = 1.175495E-38;
SYS059 :Real = 3.4E38;
SYS039 :Real = 0.57721566490153286060651200000;
SYS051 :Real = 1.192093E-07;
SYS053 :Real = 3.4E38;
HALF :Real = 0.5E0;
ONE :Real = 1.0E0;
ONPTEV :Real = 1.5E0;
TWO :Real = 2.0E0;
ULPS :Real = 1.0E0;
ZERO :Real = 0.0E0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20;
begin
{      SYS056 = SYS055 }
EULER := SYS039;   //  EQUIVALENCE
X := XX;
N := NN;
if ( X < ZERO ) 
 then X := Abs(X);
if ( N < 0 ) 
 then N := Abs(N);
RN := (N);
if ( X = ZERO ) 
 then goto _1;
EXPNX := Exp(-X);
XLOG := Ln(X);
if ( N <> 0 ) 
 then goto _4;
if ( X <= SYS056 ) 
 then goto _2;
EXPENX := ONE/X;
ENX := EXPNX*EXPENX;
goto _20;
_1:
if ( N <= 1 ) 
 then goto _2;
ENX := ONE/(RN-ONE);
goto _3;
_2:
ENX := SYS059;
_3:
EXPENX := ENX;
goto _20;
_4:
if ( X <= ULPS ) 
 then goto _5;
if ( X <= (SYS059-RN) ) 
 then goto _13;
EXPENX := ZERO;
ENX := EXPENX;
goto _20;
_5:
RM := 0;
PTERM := -ONE;
SUM := 0;
PSI := -EULER;
D := -(RN-ONE);
_6:
if ( D >= HALF ) 
 then goto _8;
if ( -D >= HALF ) 
 then goto _7;
SUM := PTERM*(XLOG-PSI)+SUM;
goto _12;
_7:
PSI := PSI+(ONE/(RM+ONE));
_8:
TM := PTERM/D;
SUM := TM+SUM;
if ( SUM < ZERO ) 
 then goto _9;
ASUM := SUM;
goto _10;
_9:
ASUM := -SUM;
_10:
if ( ASUM ) < 0
 then goto _11
 else if ( ASUM ) > 0
       then goto _11
       else goto _12;
_11:
if ( TM < ZERO ) 
 then TM := -TM;
if ( TM/ASUM > SYS051 ) 
 then goto _12;
ENX := SUM;
EXPENX := ENX/EXPNX;
goto _20;
_12:
RM := RM+ONE;
D := D+ONE;
PTERM := -(X*PTERM)/RM;
goto _6;
_13:
RM := ONE;
FMM2 := ONE;
GMM2 := 0;
FMM1 := 0;
GMM1 := ONE;
PREV := FMM1/GMM1;
AM := ONE;
BM := X+RN;
RNM1 := RN-ONE;
_14:
FM := BM*FMM1+AM*FMM2;
GM := BM*GMM1+AM*GMM2;
F := FM/GM;
TEMP := ONE-(PREV/F);
if ( TEMP > ZERO ) 
 then goto _15;
EXPENX := PREV;
goto _16;
_15:
if ( TEMP > SYS051 ) 
 then goto _17;
EXPENX := F;
_16:
ENX := EXPNX*EXPENX;
goto _20;
_17:
if ( GM < SYS053/BM ) 
 then goto _18;
FMM1 := FMM1/BM;
GMM1 := GMM1/BM;
FM := FM/BM;
GM := GM/BM;
goto _19;
_18:
if ( GM < SYS053/Abs(AM) ) 
 then goto _19;
R := Abs(AM);
FMM1 := FMM1/R;
GMM1 := GMM1/R;
FM := FM/R;
GM := GM/R;
_19:
AM := -RM*(RNM1+RM);
RM := RM+ONE;
BM := BM+TWO;
FMM2 := FMM1;
GMM2 := GMM1;
FMM1 := FM;
GMM1 := GM;
PREV := F;
goto _14;
_20:
end;

end.
